Package org.apache.lucene.queries.intervals

## Class FilteredIntervalsSource

- java.lang.Object
- - org.apache.lucene.queries.intervals.IntervalsSource
  - - org.apache.lucene.queries.intervals.FilteredIntervalsSource

-     public abstract class FilteredIntervalsSource
      extends IntervalsSource

  An IntervalsSource that filters the intervals from another IntervalsSource

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected IntervalsSource` | `in` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FilteredIntervalsSource​(String name, IntervalsSource in)` | Create a new FilteredIntervalsSource

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected abstract boolean` | `accept​(IntervalIterator it)` |
    `boolean` | `equals​(Object o)` |
    `int` | `hashCode()` |
    `IntervalIterator` | `intervals​(String field, LeafReaderContext ctx)` | Create an `IntervalIterator` exposing the minimum intervals defined by this `IntervalsSource`
    `IntervalMatchesIterator` | `matches​(String field, LeafReaderContext ctx, int doc)` | Return a `MatchesIterator` over the intervals defined by this `IntervalsSource` for a given document and field
    `static IntervalsSource` | `maxGaps​(IntervalsSource in, int maxGaps)` |
    `static IntervalsSource` | `maxWidth​(IntervalsSource in, int maxWidth)` |
    `int` | `minExtent()` | Return the minimum possible width of an interval returned by this source
    `Collection<IntervalsSource>` | `pullUpDisjunctions()` | Expert: return the set of disjunctions that make up this IntervalsSource
    `String` | `toString()` |
    `void` | `visit​(String field, QueryVisitor visitor)` | Expert: visit the tree of sources

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### in

          protected final IntervalsSource in

  - ### Constructor Detail

    - #### FilteredIntervalsSource

          public FilteredIntervalsSource​(String name,
                                         IntervalsSource in)

      Create a new FilteredIntervalsSource
      Parameters:
        `name` - the name of the filter
        `in` - the source to filter

  - ### Method Detail

    - #### maxGaps

          public static IntervalsSource maxGaps​(IntervalsSource in,
                                                int maxGaps)

    - #### maxWidth

          public static IntervalsSource maxWidth​(IntervalsSource in,
                                                 int maxWidth)

    - #### accept

          protected abstract boolean accept​(IntervalIterator it)

      Returns:
        `false` if the current interval should be filtered out

    - #### intervals

          public IntervalIterator intervals​(String field,
                                            LeafReaderContext ctx)
                                     throws IOException

      Description copied from class: `IntervalsSource`
      Create an `IntervalIterator` exposing the minimum intervals defined by this `IntervalsSource`

      Returns `null` if no intervals for this field exist in this segment

      Specified by:
        `intervals` in class `IntervalsSource`
      Parameters:
        `field` - the field to read positions from
        `ctx` - the context for which to return the iterator
      Throws:
        `IOException`

    - #### matches

          public IntervalMatchesIterator matches​(String field,
                                                 LeafReaderContext ctx,
                                                 int doc)
                                          throws IOException

      Description copied from class: `IntervalsSource`
      Return a `MatchesIterator` over the intervals defined by this `IntervalsSource` for a given document and field

      Returns `null` if no intervals exist in the given document and field

      Specified by:
        `matches` in class `IntervalsSource`
      Parameters:
        `field` - the field to read positions from
        `ctx` - the document's context
        `doc` - the document to return matches for
      Throws:
        `IOException`

    - #### minExtent

          public int minExtent()

      Description copied from class: `IntervalsSource`
      Return the minimum possible width of an interval returned by this source
      Specified by:
        `minExtent` in class `IntervalsSource`

    - #### pullUpDisjunctions

          public Collection<IntervalsSource> pullUpDisjunctions()

      Description copied from class: `IntervalsSource`
      Expert: return the set of disjunctions that make up this IntervalsSource

      Most implementations can return `Collections.singleton(this)`

      Specified by:
        `pullUpDisjunctions` in class `IntervalsSource`

    - #### visit

          public void visit​(String field,
                            QueryVisitor visitor)

      Description copied from class: `IntervalsSource`
      Expert: visit the tree of sources
      Specified by:
        `visit` in class `IntervalsSource`

    - #### equals

          public boolean equals​(Object o)

      Specified by:
        `equals` in class `IntervalsSource`

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in class `IntervalsSource`

    - #### toString

          public String toString()

      Specified by:
        `toString` in class `IntervalsSource`